
/******************************
 To compile:
  gcc -I ./.. colourImage.c ../imageFile-io.V2.0.c ../utils.c -o colourImage
*******************************/

# include "imageFile-io.h"
# include "utils.h"
# include "macros.h"

char pathNameOutput[MAXLEN], outputFileRoot[MAXLEN];

main()
 {
  unsigned char *image, *scrImage;
  unsigned char *cImage[3], *cHisto[3];

  char fileType[MAXLEN], fnInput[MAXLEN];
  char fnOutput[MAXLEN], scrName[MAXLEN];
  int pgmInput, nHead, nxImage, nyImage, nxCrop, nyCrop;
  int ix0, iy0, ix1, iy1, ix, iy;
  FILE *fpInput;
  
  /**************/
  /* Read image */
  /**************/
  fprintf(stderr, "BYTE_ORDER_TYPE = %c\n", getByteOrderType());

  /**************/
  /* Read image */
  /**************/
  fprintf(stderr, "image file type (pgm or raw) and  filename");
  scanf("%s %s", fileType, fnInput);
  /* Open image file */
  if ((fpInput = fopenInputFile(fnInput)) == NULL) 
    error("Can't open image file",fnInput);

  if (strcmp(fileType, "pgm") == 0) {
   read_pgm_image(&image, fpInput, fnInput, &nxImage, &nyImage);
  } else if (strcmp(fileType, "ppm") == 0) {
   if (read_ppm_image(cImage, fpInput, fnInput, &nxImage, &nyImage) <0)
     error("Cannot read image file", fnInput);
  } else if (strcmp(fileType, "raw") == 0) {
    fprintf(stderr, "input image size: nHeader, nx, ny :");
    scanf("%d %d %d", &nHead, &nxImage, &nyImage);
    grabByteMemory((char **) (&image), nxImage * nyImage, fnInput);
    read_byte_image_strip_bytes(image, fpInput, fnInput,
              nxImage, nyImage, nHead);
    fclose(fpInput);
  } else {
    error("Unrecognized file type for",fnInput);
  }

  /******** Read output file names ********/
  fprintf(stderr," enter output path and rootName : ");
  scanf("%s %s", pathNameOutput, outputFileRoot);
  if (checkForNull(pathNameOutput) == 0)
    pathNameOutput[0] = 0;
  if (checkForNull(outputFileRoot) == 0) {
    outputFileRoot[0] = 0;
    fprintf(stderr, " outputFileRoot = NULL, do not dump merged results\n");
  }

  /**** Dump colour channels image ****/
  nxCrop = nxImage;
  nyCrop = nyImage;
  /* Dump red image */
  strcpy(fnOutput, pathNameOutput);
  strcat(fnOutput, outputFileRoot);
  strcat(fnOutput, "_r");
  save_pgm_image(fnOutput, cImage[0], nxCrop, nyCrop);
  /* Dump red image */
  strcpy(fnOutput, pathNameOutput);
  strcat(fnOutput, outputFileRoot);
  strcat(fnOutput, "_g");
  save_pgm_image(fnOutput, cImage[1], nxCrop, nyCrop);
  /* Dump red image */
  strcpy(fnOutput, pathNameOutput);
  strcat(fnOutput, outputFileRoot);
  strcat(fnOutput, "_b");
  save_pgm_image(fnOutput, cImage[2], nxCrop, nyCrop);

}
